#include "GoogleIcon.h"
#include <stdlib.h>
#include <View.h>
#include <ctype.h>
#include <strings.h>
#include <stdio.h>       


extern "C" _EXPORT BView *instantiate_deskbar_item(void)
{
	bool expanded;
	Settings *s= new Settings;
	expanded = s->Expanded();
	delete s;
	puts("Instanciating "APP_NAME" TrayView...");
	return (new TrayView(expanded));
}

long reuseDeskbar(void *exp)
{
	bool expand = (bool)exp;
	bool persist;
	status_t err = B_OK;
	removeFromDeskbar(NULL);
	
	BDeskbar db;

	snooze(1000);
	
	Settings *s= new Settings;
	persist = s->Persist();
	delete s;
	
	// XXX: someone explains why it doesn't work please ???
	persist = true;
	if (!persist) {
		err = db.AddItem((BView *)new TrayView(expand));
	} else {
		BRoster roster;
		entry_ref ref;
		roster.FindApp(APP_SIG, &ref);
		int32 id;
		db.AddItem(&ref, &id);
	}
	printf("BDeskbar.addItem() = %08lx\n", err);
}

long removeFromDeskbar(void *)
{	
	BDeskbar db;
	printf("Removing "APP_NAME" from BDeskbar\n");
	if (db.RemoveItem(APP_NAME) != B_OK)
		printf("Unable to remove "APP_NAME" from BDeskbar\n");
		
	return 0;
}

//**************************************************

ConfigMenu::ConfigMenu(TrayView *tv, bool useMag)
	:BPopUpMenu("config_popup", false, false){

	BMenu *tmpm;
	BMenuItem *tmpi;
	BMessage *msg;
	// bigtime_t delay;
	
	Settings *s = tv->AppSettings();
	
	SetFont(be_plain_font);

	BMenuItem *autoclose = new BMenuItem("AutoClose", new BMessage(MSG_TOOGLE_AUTOCLOSE));
	autoclose->SetMarked(s->AutoClose());
	AddItem(autoclose);
	
	tmpm = new BMenu("Browser");
	tmpm->SetFont(be_plain_font);

	msg = new BMessage(MSG_SET_BROWSER);
	msg->AddInt32(GG_BROWSER, USE_DEFAULT_BROWSER);
	tmpi = new BMenuItem("Default", msg);
	tmpi->SetMarked(s->Browser() == USE_DEFAULT_BROWSER);
	tmpm->AddItem(tmpi);
	
	tmpm->AddSeparatorItem();
	
	msg = new BMessage(MSG_SET_BROWSER);
	msg->AddInt32(GG_BROWSER, USE_NET_POSITIVE);
	tmpi = new BMenuItem("NetPositive", msg);
	tmpi->SetMarked(s->Browser() == USE_NET_POSITIVE);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_BROWSER);
	msg->AddInt32(GG_BROWSER, USE_OPERA);
	tmpi = new BMenuItem("Opera", msg);
	tmpi->SetMarked(s->Browser() == USE_OPERA);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_BROWSER);
	msg->AddInt32(GG_BROWSER, USE_MOZILLA);
	tmpi = new BMenuItem("Mozilla", msg);
	tmpi->SetMarked(s->Browser() == USE_MOZILLA);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_BROWSER);
	msg->AddInt32(GG_BROWSER, USE_FIREBIRD);
	tmpi = new BMenuItem("Firebird", msg);
	tmpi->SetMarked(s->Browser() == USE_FIREBIRD);
	tmpm->AddItem(tmpi);

	tmpm->SetTargetForItems(tv);
	BMenuItem *browser = new BMenuItem(tmpm);
	
	AddItem(browser);

// Language menu
	tmpm = new BMenu("Language");
	tmpm->SetFont(be_plain_font);

	msg = new BMessage(MSG_SET_LANGUAGE);
	msg->AddInt32(GG_LANGUAGE, USE_DEFAULT_LANGUAGE);
	tmpi = new BMenuItem("Default", msg);
	tmpi->SetMarked(s->Language() == USE_DEFAULT_LANGUAGE);
	tmpm->AddItem(tmpi);
	
	tmpm->AddSeparatorItem();
	
	msg = new BMessage(MSG_SET_LANGUAGE);
	msg->AddInt32(GG_LANGUAGE, USE_LANG_NL);
	tmpi = new BMenuItem("Dutch (NL)", msg);
	tmpi->SetMarked(s->Language() == USE_LANG_NL);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_LANGUAGE);
	msg->AddInt32(GG_LANGUAGE, USE_LANG_EN);
	tmpi = new BMenuItem("English (EN)", msg);
	tmpi->SetMarked(s->Language() == USE_LANG_EN);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_LANGUAGE);
	msg->AddInt32(GG_LANGUAGE, USE_LANG_FR);
	tmpi = new BMenuItem("French (FR)", msg);
	tmpi->SetMarked(s->Language() == USE_LANG_FR);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_LANGUAGE);
	msg->AddInt32(GG_LANGUAGE, USE_LANG_DE);
	tmpi = new BMenuItem("German (DE)", msg);
	tmpi->SetMarked(s->Language() == USE_LANG_DE);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_LANGUAGE);
	msg->AddInt32(GG_LANGUAGE, USE_LANG_IT);
	tmpi = new BMenuItem("Italian (IT)", msg);
	tmpi->SetMarked(s->Language() == USE_LANG_IT);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_LANGUAGE);
	msg->AddInt32(GG_LANGUAGE, USE_LANG_PT);
	tmpi = new BMenuItem("Portuguese (PT)", msg);
	tmpi->SetMarked(s->Language() == USE_LANG_PT);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_LANGUAGE);
	msg->AddInt32(GG_LANGUAGE, USE_LANG_SP);
	tmpi = new BMenuItem("Spanish (SP)", msg);
	tmpi->SetMarked(s->Language() == USE_LANG_SP);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_LANGUAGE);
	msg->AddInt32(GG_LANGUAGE, USE_LANG_SE);
	tmpi = new BMenuItem("Swedish (SE)", msg);
	tmpi->SetMarked(s->Language() == USE_LANG_SE);
	tmpm->AddItem(tmpi);

	msg = new BMessage(MSG_SET_LANGUAGE);
	msg->AddInt32(GG_LANGUAGE, USE_LANG_RU);
	tmpi = new BMenuItem("Russian (RU)", msg);
	tmpi->SetMarked(s->Language() == USE_LANG_RU);
	tmpm->AddItem(tmpi);

	tmpm->SetTargetForItems(tv);
	BMenuItem *language = new BMenuItem(tmpm);
	AddItem(language);

	AddSeparatorItem();
//	AddItem(new BMenuItem("Settings...", new BMessage(OPEN_SETTINGS)));

// last menus	
	AddItem(new BMenuItem("About "APP_NAME, new BMessage(B_ABOUT_REQUESTED)));
	AddItem(new BMenuItem("Remove from tray", new BMessage(REMOVE_FROM_TRAY)));
		
	SetTargetForItems(tv);
	SetAsyncAutoDestruct(true);
}

ConfigMenu::~ConfigMenu() {}

//************************************************

TrayView::TrayView(bool expand)
	:BView(BRect(0, 0, B_MINI_ICON + (expand?TEXT_WIDTH:0), B_MINI_ICON -1), APP_NAME, B_FOLLOW_LEFT | B_FOLLOW_TOP, B_WILL_DRAW){
//	fExpanded = expand;
	_init(); 	//Initialization common to both constructors
}

//Rehydratable constructor
TrayView::TrayView(BMessage *mdArchive):BView(mdArchive){
//	fExpanded = false;
	_init();		//As above
}

void TrayView::GetPreferredSize(float *w, float *h)
{
	*w = B_MINI_ICON;
	*h = B_MINI_ICON - 1;
	if (AppSettings()->Expanded())
		*w += TEXT_WIDTH;
}

void TrayView::_init()
{
	status_t err;
	fIconBitmap = NULL;
	_settings = new Settings;
	_appPath = _settings->AppPath();
	
	//determine paths to icon files based on app path in settings file

	BResources res;
	BFile theapp(&_appPath, B_READ_ONLY);
	if ((err = res.SetTo(&theapp)) != B_OK) {
	
		printf("Unable to find the app to get the resources !!!\n");
//		removeFromDeskbar(NULL);
//		delete _settings;
//		return;
	}

	size_t bmsz;
	char *p;

	p = (char *)res.LoadResource('MICN', "BEOS:M:STD_ICON", &bmsz);
	fIconBitmap = new BBitmap(BRect(0, 0, B_MINI_ICON-1, B_MINI_ICON -1), B_CMAP8);
	if (!p)
		puts("ERROR loading icon");
	else
		fIconBitmap->SetBits(p, B_MINI_ICON*B_MINI_ICON, 0, B_CMAP8);
}

TrayView::~TrayView(){
	if (_settings) delete _settings;
	return;
}

//Dehydrate into a message (called by the DeskBar)
status_t TrayView::Archive(BMessage *data, bool deep = true) const {
	// status_t error=BView::Archive(data, deep);
	BView::Archive(data, deep);
	data->AddString("add_on", APP_SIG);
	data->AddRef("_appPath", &_appPath);

	return B_NO_ERROR;
}

//Rehydrate the View from a given message (called by the DeskBar)
TrayView *TrayView::Instantiate(BMessage *data) {

	if (!validate_instantiation(data, "TrayView"))
	{
		return NULL;
	}
	
	return (new TrayView(data));
}

void TrayView::AttachedToWindow() {
	if(Parent())
		SetViewColor(Parent()->ViewColor());
	// putting this in the contructor results in 2 copies (one unarchived and a newer one... 
	// and the control don't send messages
	if (AppSettings()->Expanded()) {
//		BRect pos = BRect(B_MINI_ICON, 0.0, Bounds().right, Bounds().bottom);
		BRect pos = BRect(B_MINI_ICON, -1.0, Bounds().right, Bounds().bottom -2); // odd
		fSearchEdit = new BTextControl(pos, "GoogleSearch", NULL, NULL, new BMessage(MSG_START_SEARCH));
		AddChild(fSearchEdit);
		fSearchEdit->SetTarget(this);
		fSearchEdit->MakeFocus(true);
	}
}

void TrayView::Draw(BRect updaterect) {
	// BRect bnds(Bounds());
	// int idx;
	/*
	if (Parent()) SetHighColor(Parent()->ViewColor());
	else SetHighColor(189, 186, 189, 255);
	FillRect(bnds);
*/
	SetDrawingMode(B_OP_ALPHA);

	if (fIconBitmap)
		DrawBitmap(fIconBitmap);

	SetDrawingMode(B_OP_COPY);
}

void TrayView::MouseDown(BPoint where) {
	BWindow *window = Window();	/*To handle the MouseDown message*/
	if (!window)	/*Check for proper instantiation*/
		return;
		
	BMessage *mouseMsg = window->CurrentMessage();
	if (!mouseMsg)	/*Check for existence*/
		return;
		
	if (mouseMsg->what == B_MOUSE_DOWN) {
		BDeskbar db;
		thread_id tid;

		/*Variables for storing the button pressed / modifying key*/
		uint32 	buttons = 0;
		uint32  modifiers = 0;
		
		/*Get the button pressed*/
		mouseMsg->FindInt32("buttons", (int32 *) &buttons);
		/*Get modifier key (if any)*/
		mouseMsg->FindInt32("modifiers", (int32 *) &modifiers);
		
		/*Now perform action*/
		switch(buttons) {
			 case B_PRIMARY_MOUSE_BUTTON:
				AppSettings()->SetExpanded(!AppSettings()->Expanded());
				tid = spawn_thread(reuseDeskbar, "reuseDeskbar", B_NORMAL_PRIORITY, (void *)(AppSettings()->Expanded()));
				if (tid) resume_thread(tid);
				// _settings->SetGraphType((_settings->GraphType()+1)%3); // cycle through graph types :-)
/*
				if (fTextView) {
					thread_id tid = spawn_thread(removeTVFromDeskbar, "RemoveTVFromDeskbar", B_NORMAL_PRIORITY, NULL);
					if (tid) resume_thread(tid);
					fTextView = NULL;
					ResizeToPreferred();
					ResizeBy(10.0, 0.0);
				} else {
					fTextView = new TextTrayView(this, BRect(0.0, 0.0, 31.0, B_MINI_ICON - 1));
					thread_id tid = spawn_thread(addTVToDeskbar, "AddTVToDeskbar", B_NORMAL_PRIORITY, fTextView);
					if (tid) resume_thread(tid);
					ResizeToPreferred();
					ResizeBy(20.0, 0.0);
				}
*/
				break;
			case B_SECONDARY_MOUSE_BUTTON: 
			{
				ConvertToScreen(&where);

				//menu will delete itself (see constructor of ConfigMenu),
				//so all we're concerned about is calling Go() asynchronously
				ConfigMenu *menu = new ConfigMenu(this, false);
				menu->Go(where, true, true, ConvertToScreen(Bounds()), true); 

				break;
			}
		}
	}
}	



void TrayView::MessageReceived(BMessage* message)
{

	BAlert *alert;
	const char *text;
	const char *mimesig;
	int32 browser;
	int32 language;
	
	switch(message->what)
	{
		case REMOVE_FROM_TRAY:
		{
			thread_id tid = spawn_thread(removeFromDeskbar, "RemoveFromDeskbar", B_NORMAL_PRIORITY, NULL);
			if (tid) resume_thread(tid);
		
			break;
		}
		case MSG_START_SEARCH:
//			Draw(Bounds()); // Pulse does that...
			if (fSearchEdit) {
				text = fSearchEdit->Text();
				puts(text);
				BString url;
				
				mimesig = B_URL_HTTP;

				if (!strncmp(text, "http:", 5)) { // it's an url :)
					url.Append(text);
				} else if (!strncmp(text, "www.", 4)) { // it's an url :)
					url.Append("http://");
					url.Append(text);
				} else if (!strncmp(text, "ftp:", 4)) { // it's an url :)
					mimesig = B_URL_FTP;
					url.Append(text);
				} else {
				    switch (AppSettings()->Language()) {
						case USE_DEFAULT_LANGUAGE:
							url.Append("http://www.google.com/search?q=");
							break;
						case USE_LANG_DE:
							url.Append("http://www.google.com/search?hl=de&q=");
							break;
						case USE_LANG_FR:
							url.Append("http://www.google.com/search?hl=fr&q=");
							break;
						case USE_LANG_IT:
							url.Append("http://www.google.com/search?hl=it&q=");
							break;
						case USE_LANG_SE:
							url.Append("http://www.google.com/search?hl=se&q=");
							break;
						case USE_LANG_EN:
							url.Append("http://www.google.com/search?hl=en&q=");
							break;
						case USE_LANG_PT:
							url.Append("http://www.google.com/search?hl=pt&q=");
							break;
						case USE_LANG_SP:
							url.Append("http://www.google.com/search?hl=sp&q=");
							break;
						case USE_LANG_RU:
							url.Append("http://www.google.com/search?hl=ru&q=");
							break;
						case USE_LANG_NL:
							url.Append("http://www.google.com/search?hl=nl&q=");
							break;
					}
				    				    					
					// XXX: convert text
					char *p;
					char buff[10];
					for (p = (char *)text; *p; p++) {
						if (isalnum(*p) || *p == '-') {
							url.Append(*p, 1);
						} else {
							snprintf(buff, 8, "%%%02X", *p);
							url.Append(buff);
						}
					}
					//url.Append(text);
				}
				char *args[] = {(char *)url.String()};
				
				
				switch (AppSettings()->Browser()) {
					case USE_DEFAULT_BROWSER:
//						mimesig = B_URL_HTTP;
						break;
					case USE_NET_POSITIVE:
						mimesig = "application/x-vnd.Be-NPOS";
						break;
					case USE_OPERA:
						mimesig = "application/x-vnd.operasoftware-opera";
						break;
					case USE_MOZILLA:
						mimesig = "application/x-vnd.Mozilla";
						break;
					case USE_FIREBIRD:
						mimesig = "application/x-vnd.MozillaFirebird";
						break;
				}
				puts(mimesig);
				be_roster->Launch(mimesig, 1, args);
				
				fSearchEdit->SetText("");
				
				if (AppSettings()->AutoClose()) {
					thread_id tid;
					AppSettings()->SetExpanded(!AppSettings()->Expanded());
					tid = spawn_thread(reuseDeskbar, "reuseDeskbar", B_NORMAL_PRIORITY, (void *)(AppSettings()->Expanded()));
					if (tid) resume_thread(tid);
				}
			}
			break;
		case MSG_SET_BROWSER:
			browser = AppSettings()->Browser();
			message->FindInt32(GG_BROWSER, &browser);
			AppSettings()->SetBrowser(browser);
			break;
		case MSG_SET_LANGUAGE:
			language = AppSettings()->Language();
			message->FindInt32(GG_LANGUAGE, &language);
			AppSettings()->SetLanguage(language);
			break;
		case MSG_TOOGLE_AUTOCLOSE:
			AppSettings()->SetAutoClose(!AppSettings()->AutoClose());
			break;
		case B_ABOUT_REQUESTED:
			alert = new BAlert("about box", "DeskbarGoogle, (c) 2002, mmu_man\nLocale addon: LoLL\n<subliminal>Long Live OpenBeOS !!!</subliminal>\n\nEnjoy :-)", "Ok", NULL, NULL,
                B_WIDTH_AS_USUAL, B_OFFSET_SPACING, B_INFO_ALERT);
	        alert->SetShortcut(0, B_ENTER);
    	    alert->Go(NULL);	// use the asynchronous version
			break;
		default:
			BView::MessageReceived(message);
	}
}

Settings *TrayView::AppSettings() const
{
	return _settings;
}

